# Class UIFragment.DefaultComponentFactory

java.lang.Object
com.codename1.ui.UIFragment.DefaultComponentFactory

All Implemented Interfaces:
  `UIFragment.ComponentFactory`

Enclosing class:
  `UIFragment`

public static class UIFragment.DefaultComponentFactory extends java.lang.Object implements UIFragment.ComponentFactory

Default component factory that is used in templates. Supports the following tags:

- y

- x

- flow

- layered

- border

- table

- label

- button

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultComponentFactory()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Component`
  `newComponent(Element el)`
  Creates a new component given its XML description.
  `java.lang.Object`
  `newConstraint(Container parent, Element parentEl, Component child, Element childEl)`
  Creates a layout constraint for adding a child component to a parent component.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DefaultComponentFactory

    public DefaultComponentFactory()

- ## Method Details

  - ### newComponent

    public Component newComponent(Element el)
    Description copied from interface: `UIFragment.ComponentFactory`

    Creates a new component given its XML description.

    ###### Parameters

    - `el`: The XML element

    ###### Returns

    A Component.

    Specified by:
      `newComponent` in interface `UIFragment.ComponentFactory`

  - ### newConstraint

    public java.lang.Object newConstraint(Container parent, Element parentEl, Component child, Element childEl)
    Description copied from interface: `UIFragment.ComponentFactory`

    Creates a layout constraint for adding a child component to a parent component.

    ###### Parameters

    - `parent`: The parent component.

    - `parentEl`: The XML element for the parent component.

    - `child`: The child component.

    - `childEl`: The XML element for the child component.

    ###### Returns

    Layout constraint for adding to the parent component.

    Specified by:
      `newConstraint` in interface `UIFragment.ComponentFactory`